import e32
import appuifw

lock=e32.Ao_lock()
flag_salir=False

old_title=appuifw.app.title
appuifw.app.title=u"GPS"

def avisa_salida() :
  global flag_salir
  flag_salir=True
  lock.signal()

def muestras_60segundos() :
  global out
  out="$PNMRX103,ALL,60*xx\r\n"

def muestras_15segundos() :
  global out
  out="$PNMRX103,ALL,15*xx\r\n"

def muestras_5segundos() :
 global out
 out="$PNMRX103,ALL,5*xx\r\n"

def muestras_1segundos() :
  global out
  out="$PNMRX103,ALL,1*xx\r\n"


fichero="D:\\GPS"
destino="E:\\Others\\"
grabando=False
pasar_a_tarjeta=False

def parar_grabacion() :
  global grabando
  grabando=False
  menu(m1,primera_entrada=(u"GRABAR",iniciar_grabacion))

def iniciar_grabacion() :
  global grabando
  grabando=True
  menu(m1,primera_entrada=(u"PARAR GRABACION",parar_grabacion))

appuifw.app.exit_key_handler = avisa_salida

def pasar_tarjeta() :
  global lock,pasar_a_tarjeta
  pasar_a_tarjeta=True
  lock.signal()
 
def menu(m,primera_entrada=None,ultima_entrada=None) :
  m2=m
  if ultima_entrada :
    m2=m2+[ultima_entrada]
  if primera_entrada :
    m2=[primera_entrada]+m2

  appuifw.app.menu=m2

m1=[(u"60 segundos",muestras_60segundos),
    (u"15 segundos",muestras_15segundos),
    (u"5 segundos",muestras_5segundos),
    (u"1 segundos",muestras_1segundos),
    (u"Pasar a la tarjeta",pasar_tarjeta)]

menu(m1,primera_entrada=(u"GRABAR",iniciar_grabacion))

pr=""
out=""
import time

import thread
def receptor() :
  global pr,lock,out,flag_salir

  while not flag_salir :
    try :
      import socket
      s=socket.socket(socket.AF_BT,socket.SOCK_STREAM)
      target=("00:08:1B:C0:90:0D",1)
      s.connect(target)

      while not flag_salir :
        ch=out
        if ch :
          out=""
          s.send(ch)
        ch=""
        while ch!="$" :
          ch=s.read(1)
        txt=""
        while ch!="\r" :
          txt+=ch
          ch=s.read(1)
        if txt[:6]=="$GPGGA" :
          #dummy1,hora,lat,lat2,long,long2,dummy2,sats,dummy3,alt,dummy4,dummy5,dummy6,dummy7,dummy8=txt.split(",")
          #pr="%s: %s%s %s%s - Alt: %sm - Sats: %s" %(hora,lat,lat2,long,long2,alt,sats)
          pr=txt
          lock.signal()

      try :
        s.close()
      except :
        pass

    except :
      import time
      pr=time.ctime()+": PROBLEMAS GPS"
      lock.signal()
      e32.ao_sleep(5)


thread.start_new_thread(receptor,())

while 1 :
  lock.wait()
  if flag_salir : break
  if pasar_a_tarjeta :
    pasar_a_tarjeta=False
    import os
    import time
    d=destino+"GPS-%s" %time.strftime("%Y%m%d-%H%M%S")
    print "COPIANDO..."
    e32.file_copy(d,fichero)
    print "BORRANDO ORIGINAL..."
    os.unlink(fichero)

  if pr :
    a=pr
    pr=""
    print a
    if grabando :
      f=open(fichero,"a")
      print >>f,a
      f.close()

appuifw.app.title=old_title

